DrDamage = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1", "FuBarPlugin-2.0")
local L = AceLibrary("AceLocale-2.2"):new("DrDamage")
local BS = AceLibrary("Babble-Spell-2.2")
local SEA = AceLibrary("SpecialEvents-Aura-2.0")
local GT = AceLibrary("Gratuity-2.0")
local Deformat = AceLibrary("Deformat-2.0")

local type = type
local pairs = pairs
local tonumber = tonumber
local math_abs = math.abs
local math_floor = math.floor
local math_ceil = math.ceil
local defaults = {
	--Calculation
	HitCalc = false,
	HitTarget = false,
	TargetLevel = 3,
	TargetPlayer = false,
	SpellDamage = 0,
	Healing = 0,
	ShadowDamage = 0,
	FireDamage = 0,
	NatureDamage = 0,
	FrostDamage = 0,
	ArcaneDamage = 0,
	HolyDamage = 0,
	HitRating = 0,
	CritRating = 0,
	ManualDmg = false,
	ManualPlus = false,
	ManaConsumables = false,
	--Actionbar:
	DisplayType = "Avg",
	FontEffect = "OUTLINE",
	FontSize = 10,
	FontXPosition = 0,
	FontYPosition = 0,
	FontColorDmg = { r = 1, g = 1, b = 0.2 },
	FontColorHeal = { r = 0.4, g = 1.0, b = 0.3 },
	CastsLeft = false,
	CastsLeftDmg = false,
	UpdateShift = false,
	UpdateAlt = false,
	UpdateCtrl = false,
	BlizzardAB = false,
	--Tooltip:
	Display = true,
	DefaultColor = false,
	PlusDmg = true,
	Coeffs = true,
	DispCrit = true,
	DispHit = true,
	AvgHit = true,
	AvgCrit = true,
	Ticks = true,
	Total = true,
	Extra = true,
	Next = true,
	DPS = true,
	DPM = true,
	Doom = true,
	Casts = true,
	TwoRoll = false,
	ManaUsage = false,
}
local playerClass = select(2,UnitClass("player"))
local playerHealer
if playerClass == "PRIEST" or playerClass == "SHAMAN" or playerClass == "PALADIN" or playerClass == "DRUID" then playerHealer = true end
local playerCompatible
local Mana_Cost
local visualChange = true
local playerMana = UnitManaMax( "player" )
local updateABSpell, updatingSpell, updateSetItems
local changesDMG = {
    "CHARACTER_POINTS_CHANGED",
    "PLAYER_ALIVE",
    "AceDB20_ResetDB",
}
local changesAB = {
    "ACTIONBAR_PAGE_CHANGED",
    "ACTIONBAR_HIDEGRID",
    "UPDATE_SHAPESHIFT_FORM",
    "UNIT_INVENTORY_CHANGED",
    "PLAYER_TARGET_CHANGED",
    "UPDATE_MACROS",
    "UNIT_MANA",
}

DrDamage:RegisterDB("DrDamageDB");
DrDamage:RegisterDefaults("profile", defaults )

function DrDamage:OnInitialize()
	if IsAddOnLoaded( "FlexBar2" ) then
		FlexBar2:RegisterTextSub("drd", "DrDamage_Update",
		function( Button, Frame, updateSpells )
			if not playerCompatible then return false end
			if Button:GetEffectiveAttribute('type') == 'action' then
				local id = Button:GetEffectiveAttribute( "action" )
				
				if id then
					--[[
					if updateSpells then

						local gtype, pid = GetActionInfo( id )

						if gtype == "spell" then --if gtype =="macro"?
							local spellName = GetSpellName( pid, BOOKTYPE_SPELL );	

							if DrDamage:MatchData( updateSpells, spellName ) then
								return DrDamage:CheckAction( id )
							end
						end
					else
					--]]
						return DrDamage:CheckAction( id )
					--end
				end
				return false
			end
		end)
	end
	if IsAddOnLoaded( "InfiniBar" ) then
		InfiniBar:RegisterTextSub("drd", "DrDamage_Update",
		function( bar, btn, options, updateSpells )
			if not playerCompatible then return false end
			local spellName, spellRank = bar:GetSpellNameAndRank( btn )
			if spellName and spellRank then
				if not updateSpells or DrDamage:MatchData( updateSpells, spellName ) then
					return DrDamage:CheckAction( nil, nil, nil, nil, spellName, spellRank )
				end
			end
			return false
		end)
	end
end

function DrDamage:CHARACTER_POINTS_CHANGED()
    	DrDamage:DmgUpdateTalents()
end

function DrDamage:PLAYER_ALIVE()
    	DrDamage:DmgUpdateTalents()
end

function DrDamage:ACTIONBAR_PAGE_CHANGED()
	if not self:IsEventScheduled("UpdatingAB") then
		self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(true) end, 0.5, self)
		visualChange = true
	end
end

function DrDamage:ACTIONBAR_HIDEGRID()
	if not self:IsEventScheduled("UpdatingAB") and ( GetCursorInfo() == "spell" or GetCursorInfo() == "macro" )  then
		self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(true) end, 0.5, self)
		visualChange = true
	end
end

function DrDamage:UPDATE_SHAPESHIFT_FORM()
	if self:IsEventScheduled("UpdatingAB") then
		 self:CancelScheduledEvent("UpdatingAB")
	end 
	self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(true) end, 0.5, self)
	visualChange = true
end

function DrDamage:PLAYER_TARGET_CHANGED()
	if not self:IsEventScheduled("UpdatingAB") then
		self:ScheduleEvent("UpdatingAB", self.UpdateAB, 2, self)
	end
end

function DrDamage:UPDATE_MACROS()
	if not self:IsEventScheduled("UpdatingAB") then
		self:ScheduleEvent("UpdatingAB", self.UpdateAB, 1, self)
		visualChange = true
	end
end

function DrDamage:UNIT_MANA( unit )
	if not DrDamage.db.profile.CastsLeft and not DrDamage.db.profile.CastsLeftDmg then
		do return end
	end
	
	if unit == "player" then
		local update = false
		local manaD = math_abs( UnitMana( "player" ) - playerMana )
	
		if manaD and manaD >= 200 then
			update = true
			playerMana = UnitMana( "player" )
		end
		
		if update and not self:IsEventScheduled( "UpdatingAB" ) then
			self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(false, nil, false, true) end, 1, self)
		end
	end
end

local oldValues = 0
function DrDamage:CheckBaseStats()
	local newValues = 0

	for i = 1, 7 do
		newValues = newValues + GetSpellBonusDamage(i)
		newValues = newValues + GetSpellCritChance(i)
	end

	newValues = newValues + GetSpellBonusHealing() + GetCombatRatingBonus(8)

	if playerClass == "PALADIN" then
		newValues = newValues + GetCombatRatingBonus(6) + DrDamage:TotalAP() + GetCritChance()
	end

	if newValues ~= oldValues then
		oldValues = newValues
		return true
	end

	return false	
end

local oldRangedItem
function DrDamage:UNIT_INVENTORY_CHANGED( unit )
	if unit == "player" then
		local newRangedItem, update
		
		if GetInventoryItemLink("player", GetInventorySlotInfo("RangedSlot")) then
			newRangedItem = GetItemInfo(GetInventoryItemLink("player", GetInventorySlotInfo("RangedSlot")))
		end
		if newRangedItem ~= oldRangedItem then
			oldRangedItem = newRangedItem
			update = true
		end
		if DrDamage:CheckBaseStats() or update then
			updateSetItems = true
			DrDamage:UpdateAB()		
		end
	end
end

function DrDamage:PlayerAuraUpdate( buffName )
	if self:IsEventScheduled("UpdatingAB") and not updateABSpell or not DrDamage.PlayerAura then
		do return end
	end
	
	local update, updateSpell, hide
	
	if DrDamage:CheckBaseStats() then
		DrDamage:UpdateAB()
		return
	end
	
	if BS:HasReverseTranslation( buffName ) then
		buffName = BS:GetReverseTranslation( buffName )
	end
			
	if DrDamage.PlayerAura[buffName] then
		updateSpell = DrDamage.PlayerAura[buffName].Spell
		hide = DrDamage.PlayerAura[buffName].Update
		update = true
	end
	
	if self:IsEventScheduled("UpdatingAB") and updateABSpell then
		if updatingSpell == updateSpell then
			updateABSpell = false
		end
	end	

	if update then
		if updateSpell and not updateABSpell then
			self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(false, updateSpell) end, 0.5, self)
			updateABSpell = true
			updatingSpell = updateSpell
		else
			self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(hide) end, 0.5, self)
			updateABSpell = false
		end
	end
end

function DrDamage:TargetAuraUpdate( unitID, buffName )
	if not DrDamage.HealingBuffs or not DrDamage.Debuffs or self:IsEventScheduled("UpdatingAB") and not updateABSpell then
		do return end
	end
	
	if unitID == "target" then
		local update, updateSpell
				
		if BS:HasReverseTranslation( buffName ) then
			buffName = BS:GetReverseTranslation( buffName )
		end		
		
		--|| Update healing auras only for healers ||
		if playerHealer then
			if DrDamage.HealingBuffs[buffName] then
				if DrDamage.HealingBuffs[buffName].Class then
					if DrDamage:MatchData( DrDamage.HealingBuffs[buffName].Class, playerClass ) then
						update = true
					end
				else
					update = true
				end
				
				if update then updateSpell = DrDamage.HealingBuffs[buffName].Spell end
			end
		end

		if not update then
			if DrDamage.Debuffs[buffName] then
				local debuff = DrDamage.Debuffs[buffName]
				
				if debuff.Class then
					if DrDamage:MatchData( debuff.Class, playerClass ) then
						update = true
					end				
				elseif debuff.School == "Healing" then
					if playerHealer then update = true end
				else
					update = true
				end
				
				if update then updateSpell = DrDamage.Debuffs[buffName].Spell end
			end
		end
		
		if self:IsEventScheduled("UpdatingAB") and updateABSpell then
			if updatingSpell == updateSpell then
				updateABSpell = false
			end
		end
		
		if update then
			if updateSpell and not updateABSpell then
				self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(false, updateSpell) end, 0.75, self )
				updateABSpell = true
				updatingSpell = updateSpell				
			else
				self:ScheduleEvent("UpdatingAB", self.UpdateAB, 1.5, self)
				updateABSpell = false
			end
		end
	end
end

function DrDamage:AceDB20_ResetDB( name, dab )
	if dab == DrDamage.db.name and not self:IsEventScheduled("UpdatingAB") then
		self:ScheduleEvent("UpdatingAB", self.UpdateAB, 1, self)
		visualChange = true
	end
end

local talents, spellInfo, talentEffects
local _G

function DrDamage:OnEnable()
	if not DrDamage:DetermineClass() then
		do return end
	end
	
	talents = {}
	_G = getfenv(0)
	Mana_Cost = MANA_COST
	
	DrDamage:Hook( GameTooltip, "SetAction", true)
	DrDamage:SecureHook( GameTooltip, "SetSpell" )
	DrDamage:DmgUpdateTalents()
	DrDamage:CheckBaseStats()
	
    	for i = 1, #changesDMG do
    		self:RegisterEvent(changesDMG[i])
  	end
  		
	if DrDamage.db.profile.DisplayType ~= "Off" then
    		for i = 1, #changesAB do
    			self:RegisterEvent(changesAB[i])
    		end
    		
    		self:RegisterEvent( "SpecialEvents_PlayerBuffGained", "PlayerAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_PlayerBuffCountChanged", "PlayerAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_PlayerBuffLost", "PlayerAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_PlayerDebuffGained", "PlayerAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_PlayerDebuffCountChanged", "PlayerAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_PlayerDebuffLost", "PlayerAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_UnitBuffGained", "TargetAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_UnitBuffCountChanged", "TargetAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_UnitBuffLost", "TargetAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_UnitDebuffGained", "TargetAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_UnitDebuffCountChanged", "TargetAuraUpdate" )
    		self:RegisterEvent( "SpecialEvents_UnitDebuffLost", "TargetAuraUpdate" ) 
  	end  	
end

function DrDamage:OnDisable()
	DrDamage:UpdateAB(false,nil,true)
	talents = nil
	spellInfo = nil
	talentEffects = nil	
end

function DrDamage:dGet( n )
	return function() return DrDamage.db.profile[n] end
end

function DrDamage:dSet( n, v, noUpd )
	return function(v) 
		DrDamage.db.profile[n] = v
		if not noUpd and not self:IsEventScheduled("UpdatingAB") then
			self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(true) end, 1.0, self)
		end	
	end
end

local DisplayTypes = { "Avg", "AvgHit", "AvgHitTotal", "DPS", "DPSC", "Min", "MaxHit", "Max", "Off" }
local FontEffects = { "Outline", "ThickOutline", "None" }
local options = { 
	type='group',
	args = {
		ActionBar = {
			type = "group", desc = L["Options for the actionbar"], name = L["ActionBar"],
			args = {
				DisplayType = {
					type = "text",
					name = L["Display"],
					desc = L["Choose what to display on the actionbar"],
					validate = DisplayTypes,
					get =  DrDamage:dGet("DisplayType"),
					set =  DrDamage:dSet("DisplayType", value),
					order = 70,
				}, 				
				FontSize = {
					type = 'range',
					name = L["Actionbar font size"],
					desc = L["Set the font size"],
					min = 6,
					max = 20,
					step = 1,
					order = 75,
					get =  DrDamage:dGet("FontSize"),
					set = 	function( v ) 
							DrDamage.db.profile.FontSize = v
							visualChange = true
							DrDamage:UpdateAB()
						end,
				},
				FontEffect = {
					type = "text",
					name = L["Actionbar font effect"],
					desc = L["Set the font effect"],
					validate = FontEffects,
					order = 77,
					get =	function()
							if DrDamage.db.profile.FontEffect == "" then
								return "None"
							elseif DrDamage.db.profile.FontEffect == "THICKOUTLINE" then
								return "ThickOutline"
							else
								return "Outline"
							end
						end,
					set = 	function( v )
							if v == "None" then
								DrDamage.db.profile.FontEffect = ""
							elseif v == "ThickOutline" then
								DrDamage.db.profile.FontEffect = "THICKOUTLINE"
							else
								DrDamage.db.profile.FontEffect = "OUTLINE"
							end
						
							visualChange = true
							DrDamage:UpdateAB()
						end,
				},				
				FontXPosition = {
					type = 'range',
					name = L["Actionbar font horizontal position"],
					desc = L["Set the font horizontal position"],
					min = -5,
					max = 5,
					step = 1,
					order = 80,
					get =  DrDamage:dGet("FontXPosition"),
					set = 	function( v ) 
							DrDamage.db.profile.FontXPosition = v
							visualChange = true
							DrDamage:UpdateAB()
						end,
				},
				FontYPosition = {
					type = 'range',
					name = L["Actionbar font vertical position"],
					desc = L["Set the font vertical position"],
					min = -15,
					max = 30,
					step = 1,
					order = 85,
					get =  DrDamage:dGet("FontYPosition"),
					set = 	function( v ) 
							DrDamage.db.profile.FontYPosition = v
							visualChange = true
							DrDamage:UpdateAB()
						end,
				},
				FontColorDmg = {
					type = "text",
					name = L["Damage text color"],
					desc = L["Set the actionbar damage text color"],
					usage = L["<r=n, g=n, b=n> where n is 0-1"],
					order = 90,
					get = function()
						return "r="..DrDamage.db.profile.FontColorDmg.r..", g="..DrDamage.db.profile.FontColorDmg.g..", b="..DrDamage.db.profile.FontColorDmg.b
					end,
					set = function( colors )
						for k, v in string.gmatch( string.lower( colors ), "([r|g|b])=([%d\.]+)" ) do
							local error = false
						
							if v and ( tonumber( v ) > 1 or tonumber( v ) < 0  ) or not v then
								error = true
							end
							
							if not error then
								if k == "r" then
									DrDamage.db.profile.FontColorDmg.r = v
								elseif k == "g" then
									DrDamage.db.profile.FontColorDmg.g = v
								elseif k == "b" then
									DrDamage.db.profile.FontColorDmg.b = v
								end
							end
						end
						visualChange = true
						DrDamage:UpdateAB()
					end
				},
				FontColorHeal = {
					type = "text",
					name = L["Heal text color"],
					desc = L["Set the actionbar heal text color"],
					usage = L["<r=n, g=n, b=n> where n is 0-1"],
					order = 95,
					get = function()
						return "r="..DrDamage.db.profile.FontColorHeal.r..", g="..DrDamage.db.profile.FontColorHeal.g..", b="..DrDamage.db.profile.FontColorHeal.b
					end,
					set = function( colors )
						for k, v in string.gmatch( string.lower( colors ), "([r|g|b])=([%d\.]+)" ) do
							local error = false
						
							if v and ( tonumber( v ) > 1 or tonumber( v ) < 0  ) or not v then
								error = true
							end
							
							if not error then
								if k == "r" then
									DrDamage.db.profile.FontColorHeal.r = v
								elseif k == "g" then
									DrDamage.db.profile.FontColorHeal.g = v
								elseif k == "b" then
									DrDamage.db.profile.FontColorHeal.b = v
								end
							end
						end
						visualChange = true 
						DrDamage:UpdateAB()
					end
				},				
				CastsLeftDmg = {
					type = 'toggle',
					name = L["Damage spell casts left"],
					desc = L["Toggles amount of casts left to display on actionbar for damaging spells"],
					order = 100,
					get = DrDamage:dGet( "CastsLeftDmg" ),
					set = DrDamage:dSet( "CastsLeftDmg", value ),
				},
				CastsLeft = {
					type = 'toggle',
					name = L["Healing casts left"],
					desc = L["Toggles amount of casts left to display on actionbar for heals"],
					order = 105,
					get = DrDamage:dGet( "CastsLeft" ),
					set = DrDamage:dSet( "CastsLeft", value ),
				},				
        			Update = {
            				name = L["Update"],
            				desc = L["Forces update to actionbar"],
            				type = "execute",
            				order = 110,
            				func = function() visualChange = true, DrDamage:UpdateAB(true) end,
    				},
				UpdateShift = {
					type = 'toggle',
					name = L["Updates actionbars on shift modifier key."],
					desc = L["Toggles updates on modifier key on/off. Requires Reloading UI."],
					order = 115,
					get =  DrDamage:dGet( "UpdateShift" ),
					set =  DrDamage:dSet( "UpdateShift", value, true ),				
				},
				UpdateAlt = {
					type = 'toggle',
					name = L["Updates actionbars on alt modifier key."],
					desc = L["Toggles updates on modifier key on/off. Requires Reloading UI."],
					order = 120,
					get =  DrDamage:dGet( "UpdateAlt" ),
					set =  DrDamage:dSet( "UpdateAlt", value, true ),				
				}, 
				UpdateCtrl = {
					type = 'toggle',
					name = L["Updates actionbars on ctrl modifier key."],
					desc = L["Toggles updates on modifier key on/off. Requires Reloading UI."],
					order = 125,
					get =  DrDamage:dGet( "UpdateCtrl" ),
					set =  DrDamage:dSet( "UpdateCtrl", value, true ),				
				}, 
				BlizzardAB = {
					type = 'toggle',
					name = L["Support for Blizzard AB even with other AB addons running."],
					desc = L["Toggles updating on for the default actionbar."],
					order = 130,
					get =  DrDamage:dGet( "BlizzardAB" ),
					set =  DrDamage:dSet( "BlizzardAB", value ),				
				},				
			},
		},
		Tooltip = {
			type = "group", desc = L["Options for the tooltips"], name = L["Tooltip"],
			args = {
				Display = {
					type = 'toggle',
					name = L["Tooltip on/off"],
					desc = L["Toggles the tooltip info on/off"],
					order = 50,
					get = DrDamage:dGet( "Display" ),
					set = DrDamage:dSet( "Display", value, true ),
				},
				DefaultColor = {
					type = 'toggle',
					name = L["Default tooltip colors"],
					desc = L["Toggles the default blizzard tooltip colors on/off"],
					order = 51,
					get = DrDamage:dGet( "DefaultColor" ),
					set = DrDamage:dSet( "DefaultColor", value, true ),
				},					
				PlusDmg = {
					type = 'toggle',
					name = L["Show efficient +dmg/+healing"],
					desc = L["Toggles displaying of efficient +dmg/+healing"],
					order = 52,
					get = DrDamage:dGet( "PlusDmg" ),
					set = DrDamage:dSet( "PlusDmg", value, true ),
				},
				Coeffs = {
					type = 'toggle',
					name = L["Show coefficients"],
					desc = L["Toggles displaying of spell calculation data"],
					order = 53,
					get = DrDamage:dGet( "Coeffs" ),
					set = DrDamage:dSet( "Coeffs", value, true ),
				},				
				DispCrit = {
					type = 'toggle',
					name = L["Show crit %"],
					desc = L["Toggles displaying of crit %"],
					order = 54,
					get = DrDamage:dGet( "DispCrit" ),
					set = DrDamage:dSet( "DispCrit", value, true ),
				},
				DispHit = {
					type = 'toggle',
					name = L["Show hit %"],
					desc = L["Toggles displaying of hit %."],
					order = 56,
					get = DrDamage:dGet( "DispHit" ),
					set = DrDamage:dSet( "DispHit", value, true ),
				},				
				AvgHit = {
					type = 'toggle',
					name = L["Show avg + hit range"],
					desc = L["Toggles displaying of avg hit"],
					order = 58,
					get = DrDamage:dGet( "AvgHit" ),
					set = DrDamage:dSet( "AvgHit", value, true ),
				},
				AvgCrit = {
					type = 'toggle',
					name = L["Show avg crit + crit range"],
					desc = L["Toggles displaying of avg crit"],
					order = 60,
					get = DrDamage:dGet( "AvgCrit" ),
					set = DrDamage:dSet( "AvgCrit", value, true ),
				},
				Ticks = {
					type = 'toggle',
					name = L["Show per tick/hit"],
					desc = L["Toggles displaying of per hit/tick values"],
					order = 62,
					get = DrDamage:dGet( "Ticks" ),
					set = DrDamage:dSet( "Ticks", value, true ),
				},
				Total = {
					type = 'toggle',
					name = L["Show avg total dmg/heal"],
					desc = L["Toggles displaying of average in total values"],
					order = 64,
					get = DrDamage:dGet( "Total" ),
					set = DrDamage:dSet( "Total", value, true ),
				},				
				Extra = {
					type = 'toggle',
					name = L["Show extra dmg/heal (DoT, Ignite, Chained)"],
					desc = L["Toggles displaying of extra info"],
					order = 66,
					get = DrDamage:dGet( "Extra" ),
					set = DrDamage:dSet( "Extra", value, true ),
				},
				Next = {
					type = 'toggle',
					name = L["Show next values (+1% crit, +10 dmg)"],
					desc = L["Toggles displaying of +1% crit, +10 dmg values"],
					order = 68,
					get = DrDamage:dGet( "Next" ),
					set = DrDamage:dSet( "Next", value, true ),
				},
				DPS = {
					type = 'toggle',
					name = L["Show DPS/HPS"],
					desc = L["Toggles displaying of DPS/HPS"],
					order = 70,
					get = DrDamage:dGet( "DPS" ),
					set = DrDamage:dSet( "DPS", value, true ),
				},
				DPM = {
					type = 'toggle',
					name = L["Show DPM/HPM"],
					desc = L["Toggles displaying of DPM/HPM"],
					order = 72,
					get = DrDamage:dGet( "DPM" ),
					set = DrDamage:dSet( "DPM", value, true ),
				},
				Doom = {
					type = 'toggle',
					name = L["Show Damage/healing until OOM"],
					desc = L["Toggles displaying of damage/healing until OOM"],
					order = 74,
					get = DrDamage:dGet( "Doom" ),
					set = DrDamage:dSet( "Doom", value, true ),
				},
				Casts = {
					type = 'toggle',
					name = L["Show casts and time until OOM."],
					desc = L["Toggles displaying of casts and time until OOM (regen included)"],
					order = 75,
					get = DrDamage:dGet( "Casts" ),
					set = DrDamage:dSet( "Casts", value, true ),
				},
				ManaUsage = {
					type = 'toggle',
					name = L["Show additional mana usage information."],
					desc = L["Toggles displaying of true mana cost (if different) and mana per seconds cast"],
					order = 76,
					get = DrDamage:dGet( "ManaUsage" ),
					set = DrDamage:dSet( "ManaUsage", value, true ),
				},				
			},
		},		
		Calculation = {
			type = "group", desc = L["Calculation options"], name = L["Calculation"],
			args = {
				ManaConsumables = {
					type = 'toggle',
					name = L["Include mana consumables into calculation"],
					desc = L["Toggles usage of super mana potions (Mages, also mana gems) into casts left with regen calculation."],
					order = 63,
					get = DrDamage:dGet( "ManaConsumables" ),
					set = DrDamage:dSet( "ManaConsumables", value ),
				},				
				TwoRoll = {
					type = 'toggle',
					name = L["Toggle usage of two roll hit calculation"],
					desc = L["Toggles two roll hit calculation on. Don't change this unless you know what this does."],
					order = 64,
					get = DrDamage:dGet( "TwoRoll" ),
					set = DrDamage:dSet( "TwoRoll", value ),
				},			
				HitCalc = {			
					type = 'toggle',
					name = L["+Hit calculation"],
					desc = L["Toggles +hit calculation effects into averages on/off"],
					order = 65,
					get = DrDamage:dGet( "HitCalc" ),
					set = DrDamage:dSet( "HitCalc", value ),
				},
				HitTarget = {			
					type = 'toggle',
					name = L["Hit calculation by target level"],
					desc = L["Toggles +hit calculation by target level."],
					order = 66,
					get = DrDamage:dGet( "HitTarget" ),
					set = DrDamage:dSet( "HitTarget", value ),
				},
				TargetLevel = {
					type = 'range',
					name = L["Manual target level setting"],
					desc = L["Manual set of target level compared to your level. Make sure 'HitTarget' is turned off to use this."],
					min = -10,
					max = 10,
					step = 1,
					order = 67,
					get = DrDamage:dGet( "TargetLevel" ),
					set = DrDamage:dSet( "TargetLevel", value ),
				},
				TargetPlayer = {
					type = 'toggle',
					name = L["Manual target is a player."],
					desc = L["Toggles if your manually set target is a player."],
					order = 68,
					get = DrDamage:dGet( "TargetPlayer" ),
					set = DrDamage:dSet( "TargetPlayer", value ),
				},				
				ManualDmg = {
					type = 'toggle',
					name = L["Manual variables"],
					desc = L["Allows you to manually set damage/healing properties"],
					order = 71,
					get = DrDamage:dGet( "ManualDmg" ),
					set = DrDamage:dSet( "ManualDmg", value ),
				},
				ManualPlus = {
					type = 'toggle',
					name = L["Manual damage adds to detected"],
					desc = L["Allows you to set if manual values should add to detected values"],
					order = 72,
					get = DrDamage:dGet( "ManualPlus" ),
					set = DrDamage:dSet( "ManualPlus", value ),
				}, 
				Healing = {
					type = 'range',
					name = L["Healing"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your +healing"],
					order = 79,
					get = DrDamage:dGet("Healing"),
					set = DrDamage:dSet("Healing", value),
				},				
				SpellDamage = {
					type = 'range',
					name = L["Spell Damage"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your spell damage"],
					order = 80,
					get = DrDamage:dGet("SpellDamage"),
					set = DrDamage:dSet("SpellDamage", value),
				},		
				FireDamage = {
					type = 'range',
					name = L["Fire Damage"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your fire +damage"],
					order = 81,
					get = DrDamage:dGet("FireDamage"),
					set = DrDamage:dSet("FireDamage", value),		
		
				},
				ShadowDamage = {
					type = 'range',
					name = L["Shadow Damage"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your shadow +damage"],
					order = 82,
					get = DrDamage:dGet("ShadowDamage"),
					set = DrDamage:dSet("ShadowDamage", value),		
				},
				FrostDamage = {
					type = 'range',
					name = L["Frost Damage"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your frost +damage"],
					order = 83,
					get = DrDamage:dGet("FrostDamage"),
					set = DrDamage:dSet("FrostDamage", value),		
				},
				NatureDamage = {
					type = 'range',
					name = L["Nature Damage"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your nature +damage"],
					order = 84,
					get = DrDamage:dGet("NatureDamage"),
					set = DrDamage:dSet("NatureDamage", value),		
				},
				ArcaneDamage = {
					type = 'range',
					name = L["Arcane Damage"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your arcane +damage"],
					order = 85,
					get = DrDamage:dGet("ArcaneDamage"),
					set = DrDamage:dSet("ArcaneDamage", value),		
				},
				HolyDamage = {
					type = 'range',
					name = L["Holy Damage"],
					min = -500,
					max = 2000,
					step = 1,
					desc = L["Input your holy +damage"],
					order = 85,
					get = DrDamage:dGet("HolyDamage"),
					set = DrDamage:dSet("HolyDamage", value),		
				},					
				CritRating = {
					type = 'range',
					name = L["Manual critical rating"],
					min = -400,
					max = 1000,
					step = 1,
					desc = L["Input critical rating you want to use."],
					order = 88,
					get = DrDamage:dGet("CritRating"),
					set = DrDamage:dSet("CritRating", value),					
				},
				HitRating = {
					type = 'range',
					name = L["Manual hit rating"],
					min = -200,
					max = 500,
					step = 1,
					desc = L["Input hit rating you want to use."],
					order = 89,
					get = DrDamage:dGet("HitRating"),
					set = DrDamage:dSet("HitRating", value),	
				},
			},
		},
	},
}

DrDamage:RegisterChatCommand( { "/drdmg", "/drdamage" }, options)

--FuBar options
DrDamage.name = "DrDamage"
DrDamage.title = "Dr. Damage"
DrDamage.hasNoColor = true
DrDamage.hasNoText = true
DrDamage.cannotDetachTooltip = true
DrDamage.OnMenuRequest = options
DrDamage.hideWithoutStandby = true
DrDamage.independentProfile = true
DrDamage.hasIcon = "Interface\\Icons\\Spell_Holy_SearingLightPriest"

function DrDamage:ClearTable( table )
	for k in pairs( table ) do
		table[k] = nil
	end
end

function DrDamage:DmgUpdateTalents()
	DrDamage:ClearTable( talents )

	for t = 1, GetNumTalentTabs() do	
		for i = 1, GetNumTalents(t) do
			local nameTalent, _, _, _, currRank = GetTalentInfo( t, i )

			if BS:HasReverseTranslation( nameTalent ) then
				nameTalent = BS:GetReverseTranslation( nameTalent )
			end

			if currRank ~= 0 then
				if talentEffects[nameTalent] then
					if talentEffects[nameTalent].Locale then
						if DrDamage:MatchData( talentEffects[nameTalent].Locale, GetLocale() ) then
							talents[nameTalent] = currRank
						end
					else
						talents[nameTalent] = currRank
					end
					--self:Print("Talent name: " .. nameTalent .. " Points: " .. currRank )
				end
			end	    	    
		end
	end
	if not self:IsEventScheduled("UpdatingAB") then
		self:ScheduleEvent("UpdatingAB", self.UpdateAB, 1.5, self)
	end
end

local SetItems = {}

function DrDamage:GetSetAmount(set)
	if not updateSetItems and SetItems[set] then
		return SetItems[set]
	end
	
	if updateSetItems then
		DrDamage:ClearTable( SetItems )
		updateSetItems = false
	end
	
	local amount = 0
	local setData = DrDamage.SetBonuses[set]
	if setData then
		for _, itemID in ipairs(setData) do
			if IsEquippedItem(itemID) then
				amount = amount + 1
			end
		end
	end
	SetItems[set] = amount
	return amount
end

function DrDamage:DetermineClass()
	self.ClassSpecials = {}
	self.Calculation = {}
	self.RelicSlot = {}
	self.SetBonuses = {}

	if DrDamage.PlayerData then
		spellInfo, talentEffects = DrDamage.PlayerData()
		playerCompatible = true
		return true
	end
end

function DrDamage:MatchData( data, ... )
	if not data or not ... then
		return false
	end

	if type( data ) == "table" then
		for _, dataName in ipairs( data ) do
			for i = 1, select('#', ...) do
				if dataName == select(i, ...) then
					return true
				end
			end
		end
	else	
		for i = 1, select('#', ...) do
			if data == select(i, ...) then
				return true
			end
		end
	end
	
	return false
end

function DrDamage:SetSpell( frame, slot )
	if not DrDamage.db.profile.Display then
		do return end
	end
		
	GT:SetSpell( slot, BOOKTYPE_SPELL )
	local spellName, spellRank = GetSpellName( slot, BOOKTYPE_SPELL );
	
	if spellRank then 
		spellRank = tonumber(spellRank:match("%d+"))
	end
	
	if not spellRank then
		spellRank = "None"
	end
	
	DrDamage:DoTooltip( frame, spellName, spellRank )
end

function DrDamage:SetAction( frame, slot )
	self.hooks[frame].SetAction(frame, slot)
	
	if not DrDamage.db.profile.Display then
		do return end
	end

	GT:SetAction( slot )	
	local gtype = GetActionInfo( slot )
	local spellName, spellRank = frame:GetSpell()

	if gtype == "spell" or gtype == "macro" then
		if spellName then 
			if spellRank then 
				spellRank = tonumber(spellRank:match("%d+"))
			end
			if not spellRank then
				spellRank = "None"
			end			
			DrDamage:DoTooltip( frame, spellName, spellRank )
		end
	end
end

local function FreeCrits( casts, canCrit, freeCrit, critRate )
	if canCrit and freeCrit and freeCrit > 0 then
		local total = casts

		for i = 1, 5 do	--5 loops enough?
			casts = math_floor( freeCrit * ( critRate / 100 ) * casts )

			if casts == 0 then
				break
			end									
			total = total + casts
		end
		return total
	end
	return casts
end

local TooltipData = {}

function DrDamage:DoTooltip( frame, spellName, spellRank )
	if spellName and spellRank then
		if spellInfo[spellName] then
			local baseSpell = spellInfo[spellName][0]
			local tableSpell = spellInfo[spellName][spellRank]
			
			if not tableSpell then
				tableSpell = spellInfo[spellName]["None"]
			end
			
			if tableSpell and not baseSpell.NoTooltip then
				local healingSpell, AvgTotal, DPS, DPSC, AvgDmg, MinDmg, MaxDmg, AvgHitTotal, MaxCrit, TooltipData = DrDamage:RawNumbers ( tableSpell, spellName, true )
				local DPM, DOOM, SOOM, castsOOM, ManaCost, TrueManaCost, MPS
				local regenCasts = 0
				
				if GT:GetLine(2) and Mana_Cost then
					ManaCost = Deformat(GT:GetLine(2), Mana_Cost)
				end

				if ManaCost then
					ManaCost = tonumber( ManaCost )
					if ManaCost > 0 then
						if TooltipData.FreeCrit and TooltipData.CritRate and TooltipData.CritRate < 100 then
							DPM = DrDamage:Round( ( AvgTotal / ManaCost ) / ( 1 - ( TooltipData.CritRate / 100 ) * TooltipData.FreeCrit ), 1 )
							TrueManaCost = DrDamage:Round( ManaCost * ( 1 - (TooltipData.CritRate / 100 ) * TooltipData.FreeCrit), 1 )
						else
							DPM = DrDamage:Round( AvgTotal / ManaCost, 1 )
						end

						local PlayerMana = UnitMana("player")
						local regen = 0

						if DrDamage.db.profile.Casts and PlayerMana then				
							local Cooldown = TooltipData.Cooldown
							local ManaRegen = TooltipData.ManaRegen
							local CastTime = TooltipData.CastTime

							if Cooldown > 0 and Cooldown <= 10 then
								CastTime = Cooldown
							end

							if Cooldown <= 10 then
								regen = math_floor( PlayerMana / ManaCost ) * CastTime * ManaRegen
								local newCasts = FreeCrits( math_floor( regen / ManaCost ), baseSpell.canCrit, TooltipData.FreeCrit, TooltipData.CritRate )
								regenCasts = regenCasts + newCasts

								for i = 1, 5 do
									local newRegen = newCasts * CastTime * ManaRegen
									newCasts = FreeCrits( math_floor( newRegen / ManaCost ), baseSpell.canCrit, TooltipData.FreeCrit, TooltipData.CritRate )
									regen = regen + newRegen
									regenCasts = regenCasts + newCasts

									if newCasts == 0 then
										break
									end
								end
							end

							castsOOM = FreeCrits( math_floor( PlayerMana / ManaCost ), baseSpell.canCrit, TooltipData.FreeCrit, TooltipData.CritRate )
							SOOM = DrDamage:Round( ( castsOOM + regenCasts ) * CastTime, 1 )

							if ( castsOOM + regenCasts ) > 1000 then
								castsOOM = "\226\136\158"
								SOOM = nil
							end
						end

						if TrueManaCost then
							MPS = DrDamage:Round( TrueManaCost / TooltipData.CastTime, 1 )
						else
							MPS = DrDamage:Round( ManaCost / TooltipData.CastTime, 1 )
						end

						if PlayerMana then
							DOOM = DrDamage:Round( DPM * ( PlayerMana + regen ) )

							if DOOM > 1000000 then
								DOOM = "1000000+"
							end
						end
					end
				end
				
				frame:AddLine(" ")
				
				local r, g, b = 1, 0.82745098, 0
				
				if not DrDamage.db.profile.DefaultColor then
					r, g, b = 0, 0.7, 0
				end
				
				local spellType, spellAbbr
				
				if healingSpell then
					spellType = L["Heal"]
					spellAbbr = L["H"]
				else
					spellType = L["Dmg"]
					spellAbbr = L["D"]
				end
				
				if DrDamage.db.profile.PlusDmg then
					frame:AddDoubleLine( "+" .. spellType .. L[" (eff.):"], "+" .. DrDamage:Round( TooltipData.SpellDmg * TooltipData.SpellDmgM * TooltipData.DmgM, 1 ), 1, 1, 1, r, g, b  )
				end
				
				if DrDamage.db.profile.Coeffs then
					frame:AddDoubleLine(L["Coeffs:"], TooltipData.DmgM .. "/" .. TooltipData.SpellDmgM .."/" .. TooltipData.SpellDmg, 1, 1, 1, r, g, b  )
				end
  				
  				if DrDamage.db.profile.DispCrit and TooltipData.CritRate then
  					frame:AddDoubleLine(L["Crit:"], TooltipData.CritRate .. "%", 1, 1, 1, r, g, b )
  				end
  				
  				if DrDamage.db.profile.DispHit and not baseSpell.Unresistable and not healingSpell then
  					frame:AddDoubleLine(L["Hit:"], TooltipData.HitRate .. "%", 1, 1, 1, r, g, b )
  				end  				
  				
  				if not DrDamage.db.profile.DefaultColor then
  					r, g, b = 0.8, 0.8, 0.9
  				end
  				
  				if DrDamage.db.profile.AvgHit then
  					frame:AddDoubleLine(L["Avg:"], AvgDmg .. " (".. MinDmg .."-".. MaxDmg ..")", 1, 1, 1, r, g, b )
  					
  					if baseSpell.Leech and TooltipData.AvgLeech and TooltipData.AvgLeech > AvgDmg then
  						frame:AddDoubleLine(L["Avg Heal:"], TooltipData.AvgLeech, 1, 1, 1, r, g, b )
  					end
  				end
  				
  				if DrDamage.db.profile.AvgCrit and TooltipData.AvgCrit and not baseSpell.sHits then
  					frame:AddDoubleLine(L["Avg Crit:"], TooltipData.AvgCrit .. " (".. TooltipData.MinCrit .."-".. TooltipData.MaxCrit ..")", 1, 1, 1, r, g, b )
  				end
  				
  				if DrDamage.db.profile.Ticks and TooltipData.PerHit then
  					if baseSpell.sHits then
  						frame:AddDoubleLine( L["Hits:"], TooltipData.Hits .. "x ~" .. TooltipData.PerHit, 1, 1, 1, r, g, b )
  						
						if baseSpell.Leech and TooltipData.PerHitHeal and TooltipData.PerHitHeal > TooltipData.PerHit then
							frame:AddDoubleLine( L["Hits Heal:"], TooltipData.Hits .. "x ~" .. TooltipData.PerHitHeal, 1, 1, 1, r, g, b )
						end  						
  					elseif baseSpell.sTicks then
  						frame:AddDoubleLine( L["Ticks:"], TooltipData.Hits .. "x ~" .. TooltipData.PerHit, 1, 1, 1, r, g, b )
  						
						if baseSpell.Leech and TooltipData.PerHitHeal and TooltipData.PerHitHeal > TooltipData.PerHit then
							frame:AddDoubleLine( L["Ticks Heal:"], TooltipData.Hits .. "x ~" .. TooltipData.PerHitHeal, 1, 1, 1, r, g, b )
						end  						
  					end
  				end
  				
  				if DrDamage.db.profile.Extra then 
  					if TooltipData.ChainDmg then
  						frame:AddDoubleLine(L["Avg Chain:"], TooltipData.ChainDmg, 1, 1, 1, r, g, b  )
  					end
  				
  					if TooltipData.IgniteDmg then
  						frame:AddDoubleLine(L["Ignite:"], TooltipData.IgniteDmg, 1, 1, 1, r, g, b )
  					end
  				
   					if TooltipData.DotDmg > 0 then
  						frame:AddDoubleLine(L["DoT:"], TooltipData.DotDmg, 1, 1, 1, r, g, b )
  					end
  				end  				
  				
  				if DrDamage.db.profile.Total and AvgTotal > AvgDmg then
  					frame:AddDoubleLine(L["Avg Total:"], AvgTotal, 1, 1, 1, r, g, b  )
  				end
  				
  				if not DrDamage.db.profile.DefaultColor then
  					r, g, b = 0.3, 0.6, 0.5
  				end
  								
  				if DrDamage.db.profile.Next and not baseSpell.NoNext then
  				
  					local critA, hitA, dmgA
  				
  					if TooltipData.NextCrit then
  						frame:AddDoubleLine("+1%/" .. DrDamage:GetRating() .. " " .. L["Crit:"], "+" .. TooltipData.NextCrit .. " (" .. DrDamage:Round( ( TooltipData.NextCrit * 10 ) / TooltipData.NextTenDmg, 1 ) .. " +" .. spellType .. ")", 1, 1, 1, r, g, b )
  						critA = DrDamage:Round( AvgTotal * 0.01 / TooltipData.NextCrit * DrDamage:GetRating( nil, nil, true ), 1 )
  					end
  					
  					if TooltipData.NextHit then
  						frame:AddDoubleLine("+1%/" .. DrDamage:GetRating( true ) .. " " .. L["Hit:"], "+" .. TooltipData.NextHit .. " (" .. DrDamage:Round( ( TooltipData.NextHit * 10 ) / TooltipData.NextTenDmg, 1 ) .. " +" .. spellType .. ")", 1, 1, 1, r, g, b )
  						if TooltipData.NextHit > 1 then
  							hitA = DrDamage:Round( AvgTotal * 0.01 / TooltipData.NextHit * DrDamage:GetRating( true, nil, true ), 1 )
  						else
  							hitA = "-"
  						end
  					end
  				
  					frame:AddDoubleLine("+10 " .. spellType .. ":", "+" .. TooltipData.NextTenDmg, 1, 1, 1, r, g, b )
  					dmgA = DrDamage:Round( ( AvgTotal * 0.1) / TooltipData.NextTenDmg, 1 )
  					
  					if critA and hitA then
  						frame:AddDoubleLine("+1% Total (Cr/Ht/" ..spellType .. "):", critA .. "/" .. hitA .. "/" .. dmgA, 1, 1, 1, r, g, b )
  					elseif critA then
  						frame:AddDoubleLine("+1% Total (Cr/" .. spellType .. "):", critA .. "/" .. dmgA, 1, 1, 1, r, g, b )
  					elseif hitA then
  						frame:AddDoubleLine("+1% Total (Ht/" .. spellType .. "):", hitA .. " /" .. dmgA, 1, 1, 1, r, g, b )
  					else
  						frame:AddDoubleLine("+1% Total (" .. spellType .. "):", dmgA, 1, 1, 1, r, g, b )
  					end
  				end
  				
  				if not DrDamage.db.profile.DefaultColor then
  					r, g, b = 0.8, 0.1, 0.1
  				end
  				
  				if DrDamage.db.profile.DPS and not baseSpell.NoDPS then
  					if DPSC ~= DPS then
  						if TooltipData.ExtraDPS then
  							frame:AddDoubleLine( spellAbbr .. L["PS/"] .. spellAbbr .. L["PSC:"], DPS .. "+" .. TooltipData.ExtraDPS .. "/" .. DPSC, 1, 1, 1, r, g, b)
  						else
  							frame:AddDoubleLine( spellAbbr .. L["PS/"] .. spellAbbr .. L["PSC:"], DPS .. "/" .. DPSC, 1, 1, 1, r, g, b)
  						end
      					else
      						if TooltipData.ExtraDPS then
      							frame:AddDoubleLine( spellAbbr .. L["PS:"], DPS .. "+" .. TooltipData.ExtraDPS, 1, 1, 1, r, g, b)
      						else
      							frame:AddDoubleLine( spellAbbr .. L["PS:"], DPS, 1, 1, 1, r, g, b)
      						end
      					end
      					
					if TooltipData.DPSCD then
						frame:AddDoubleLine( spellAbbr .. L["PS (CD):"], TooltipData.DPSCD, 1, 1, 1, r, g, b)
					end  					
      				end
      				
      				if DrDamage.db.profile.DPM and DPM and not baseSpell.NoDPM then
      					frame:AddDoubleLine( spellAbbr .. L["PM:"], DPM, 1, 1, 1, r, g, b )
      				end
      				
      				if DrDamage.db.profile.Doom and DOOM and not baseSpell.NoDoom then
      					frame:AddDoubleLine( spellType .. L[" until OOM:"], DOOM, 1, 1, 1, r, g, b )
      				end
      				
      				if DrDamage.db.profile.Casts and castsOOM then
					if TooltipData.Cooldown <= 10 and not baseSpell.eDot then
						if SOOM then
							if regenCasts > 0 then
								frame:AddDoubleLine(L["Casts (rgn):"], castsOOM .. "+" .. regenCasts .." (" .. SOOM .. "s)", 1, 1, 1, r, g, b )
							else
								frame:AddDoubleLine(L["Casts (rgn):"], castsOOM .." (" .. SOOM .. "s)", 1, 1, 1, r, g, b )
							end
						else
							frame:AddDoubleLine(L["Casts (rgn):"], castsOOM, 1, 1, 1, r, g, b )
						end
					else
						frame:AddDoubleLine(L["Casts:"], castsOOM, 1, 1, 1, r, g, b )
					end
      				end
      				
      				if DrDamage.db.profile.ManaUsage then
      					if TrueManaCost then
      						frame:AddDoubleLine( L["True Mana Cost:"], TrueManaCost, 1, 1, 1, r, g, b )
      					end
      					
      					if MPS then
      						frame:AddDoubleLine( L["MPS:"], MPS, 1, 1, 1, r, g, b )
      					end
      				end
      				
				DrDamage:ClearTable( TooltipData )
      				frame:Show()			
			end  			
		end	  
	end
end
	
local ABscan, ABstop, ABdefault, ABtable, ABgetID, ABglobalbutton, CTBar
local defaultBars = { "MultiBarBottomLeftButton", "MultiBarBottomRightButton","MultiBarRightButton", "MultiBarLeftButton" }
		
function DrDamage:MODIFIER_STATE_CHANGED( state )
	if state == "ALT" and DrDamage.db.profile.UpdateAlt or state == "CTRL" and DrDamage.db.profile.UpdateCtrl or state == "SHIFT" and DrDamage.db.profile.UpdateShift then
		if not self:IsEventScheduled("UpdatingAB") then
			self:ScheduleEvent("UpdatingAB", function() DrDamage:UpdateAB(true) end, 0.3, self)
			visualChange = true
		end
	end
end

function DrDamage:DetermineAB()
	if IsAddOnLoaded("Bartender3") then
		ABglobalbutton = "BT3Button"
		ABtable = Bartender3.actionbuttons
		ABgetID = function( button, index, ABtable )
					if ABtable[index] and ABtable[index].state == "used" then
						return ABtable[index].object:PagedID()
					end
		end	
	elseif IsAddOnLoaded( "Bongos2" ) then
		ABglobalbutton = "BongosActionButton"
		ABgetID = function( button ) return SecureButton_GetModifiedAttribute(button,"action",SecureStateChild_GetEffectiveButton(button)) end
	elseif IsAddOnLoaded( "Bongos" ) then
		ABglobalbutton = "BActionButton"
		ABgetID = function( button ) return SecureButton_GetModifiedAttribute(button,"action",SecureStateChild_GetEffectiveButton(button)) end
	elseif IsAddOnLoaded( "CogsBar" ) then
		ABglobalbutton = "CogsBarButton"
		ABgetID = function( button ) return SecureButton_GetModifiedAttribute(button,"action",SecureStateChild_GetEffectiveButton(button)) end
	elseif IsAddOnLoaded("TrinityBars") then
		ABglobalbutton = "TrinityActionButton"
		ABgetID = function( button ) return button:GetID() end
	elseif IsAddOnLoaded( "InfiniBar" ) or IsAddOnLoaded( "FlexBar2" ) then
		ABstop = true
	elseif IsAddOnLoaded("DiscordActionBars") then
		ABglobalbutton = "DAB_ActionButton_"
		ABgetID = function( button ) return button:GetActionID() end
	elseif IsAddOnLoaded("Nurfed") then
		ABglobalbutton = "Nurfed_Button"
		ABgetID = function( button )
			if button.type == "spell" and button.spell then
				local pos = string.find( button.spell, "%(" )
				if pos then pos = pos - 1
				else pos = string.len( button.spell ) end
				return nil, string.sub( button.spell, 1, pos ), button.spell:match("%d+")
			elseif button.type == "macro" and button.spell then
				local action = GetActionFromMacroText(GetMacroBody(button.spell))
				local pid
				if action and not GetItemInfo(action) then pid = Nurfed:getspell(action) end
				if pid then return nil, GetSpellName(pid, BOOKTYPE_SPELL), pid end			
			end
		end		
	elseif IsAddOnLoaded("CT_BarMod") then
		CTBar = true
		ABtable = CT_BarMod.actionButtonList
		ABgetID = function( button, index, ABtable )
			if ABtable[index] and ABtable[index].hasAction then return index end
		end		
	else
		ABdefault = true
	end
	
	if DrDamage.db.profile.UpdateAlt or DrDamage.db.profile.UpdateCtrl or DrDamage.db.profile.UpdateShift then
		self:RegisterEvent( "MODIFIER_STATE_CHANGED" )
	end
	
	ABscan = true
end

function DrDamage:UpdateAB(hide, updateSpell, disable, manaUpdate)

	DrDamage:TriggerEvent("DrDamage_Update", updateSpell )

	--[[	Used for debugging updates.
	if updateSpell then
		self:Print( "Update AB: Spell" )
		
		if type( updateSpell ) == "table" then
			for _, gar in ipairs( updateSpell ) do
				self:Print( "Updating: " .. gar )
			end
		else
			self:Print( "Updating: " .. updateSpell )
		end
	else
		self:Print( "Update AB: All" )
	end
	--]]

	if not ABscan then DrDamage:DetermineAB() end
	if DrDamage.db.profile.BlizzardAB and not ABdefault then ABdefault = true end
	if ABstop and not ABdefault then do return end end
	
	if ABglobalbutton then
		for i = 1, 120 do	
			DrDamage:ProcessButton( _G[ABglobalbutton..i], i, hide, updateSpell, disable, manaUpdate )
		end
	elseif CTBar then
		for i = 1, 12 do
			if _G["BonusActionButton"..i]:IsVisible() then
				DrDamage:ProcessButton( _G["BonusActionButton"..i], nil, true, updateSpell, disable, manaUpdate, true )
			else		
				DrDamage:ProcessButton( _G["ActionButton"..i], nil, true, updateSpell, disable, manaUpdate, true )
			end
		end
		for i, list in pairs( ABtable ) do
			DrDamage:ProcessButton( list.button, i, hide, updateSpell, disable, manaUpdate )
		end	
	end
	
	if ABdefault then
		if not DrDamage.db.profile.BlizzardAB and ( CTBar or ABglobalbutton ) then
			disable = true
			ABdefault = false
		end
		if not CTBar then
			for i = 1, 12 do
				if _G["BonusActionButton"..i]:IsVisible() then
					DrDamage:ProcessButton( _G["BonusActionButton"..i], nil, true, updateSpell, disable, manaUpdate, true )
				else		
					DrDamage:ProcessButton( _G["ActionButton"..i], nil, true, updateSpell, disable, manaUpdate, true )
				end
			end
		end
		for bar = 1, 4 do
			for i = 1, 12 do
				DrDamage:ProcessButton( _G[defaultBars[bar]..i], nil, hide, updateSpell, disable, manaUpdate, true )
			end
		end
	end
					
	updateABSpell = nil
	updatingSpell = nil
	visualChange = nil
end

local function GetTextFrame( hide, ... )
	for i = 1, select('#', ...) do
		local frame = select(i, ...)
		if frame and frame:GetName() == "DrDamageText" and frame.text then
			if hide then frame.text:Hide() end
			return frame
		end
	end
end

function DrDamage:ProcessButton( button, index, hide, updateSpell, disable, manaUpdate, defaultBar )
	if not button then do return end end

	local textFrame

	if disable or hide then
		textFrame = GetTextFrame(true,button:GetChildren())
	end
	
	if DrDamage.db.profile.DisplayType == "Off" or disable then
		do return end
	end

	if button:IsVisible() then
		local id, spellName, spellRank, pid
		
		if defaultBar then 
			id = ActionButton_GetPagedID( button )
		elseif ABgetID then
			id, spellName, spellRank, pid = ABgetID( button, index, ABtable ) 
		end

		if id then
			if HasAction(id) then
				DrDamage:CheckAction(id, button, manaUpdate, updateSpell, nil, nil, textFrame)
			end
		elseif spellName and spellRank then
			DrDamage:CheckAction(nil, button, manaUpdate, updateSpell, spellName, spellRank, textFrame, pid)
		end
	end
end

local displayTypeTable = { ["Avg"] = 2, ["DPS"] = 3, ["DPSC"] = 4, ["AvgHit"] = 5, ["Min"] = 6, ["MaxHit"] = 7, ["AvgHitTotal"] = 8, ["Max"] = 9, }

function DrDamage:CheckAction(id, button, manaUpdate, updateSpell, spellName, spellRank, textFrame, pid)
	local gtype
	
	if DrDamage.db.profile.DisplayType == "Off" then return "" end
	
	if id then
		gtype, pid = GetActionInfo(id)

		if gtype == "spell" then
			spellName, spellRank = GetSpellName(pid, BOOKTYPE_SPELL)
		elseif gtype == "macro" then
			GT:SetAction(id)
			spellName = GT:GetLine(1, false)
			spellRank = GT:GetLine(1, true)

			if not spellName and not spellRank and button then
				local macroText = _G[button:GetName().."Name"]
				if macroText then macroText:Show() end			
			end
		end
	end
	if spellName then
		if updateSpell then
			if not DrDamage:MatchData(updateSpell, spellName) then return end
			updateABSpell = false
			--self:Print( "Spell matched." )
		end	
	
		if spellName == BS["Shoot"] then
			return DrDamage:SpecialSlot(DrDamage.WandDamage, button, nil, textFrame)
		elseif DrDamage.ClassSpecials[spellName] then
			return DrDamage:SpecialSlot(DrDamage.ClassSpecials[spellName], button, healingSpell, textFrame)
		end
	
		if spellRank and spellInfo[spellName] then
			local baseSpell = spellInfo[spellName][0]
			local tableSpell = spellInfo[spellName][tonumber(spellRank:match("%d+")) or "None"]

			if tableSpell then
				if gtype == "macro" and button then
					local macroText = _G[button:GetName().."Name"]
					if macroText then macroText:Hide() end
					if CTBar then if button.name then button.name:SetText("") end end
				end
				
				local healingSpell = baseSpell.Healing or DrDamage:MatchData(baseSpell.School, "Healing")

				if (id or pid) and (DrDamage.db.profile.CastsLeft and healingSpell or DrDamage.db.profile.CastsLeftDmg and not healingSpell) then
					local ManaCost

					if id then GT:SetAction(id)
					else GT:SetSpell(pid, BOOKTYPE_SPELL) end

					if GT:GetLine(2) and Mana_Cost then
						ManaCost = Deformat(GT:GetLine(2), Mana_Cost)
					end				

					if ManaCost then
						ManaCost = tonumber(ManaCost)

						if ManaCost > 0 then
							if button then return DrDamage:CreateABtext(button, math_floor(UnitMana("player")/ManaCost), healingSpell, textFrame)
							else return math_floor(UnitMana("player") / ManaCost) end
						else
							if button then return DrDamage:CreateABtext(button, "\226\136\158", healingSpell, textFrame)
							else return "\226\136\158" end							
						end
					end
				end

				if manaUpdate then do return end end

				local selector = displayTypeTable[DrDamage.db.profile.DisplayType]
				if baseSpell.NoDPS and (selector == 3 or selector == 4) then selector = 2 end

				if button then
					DrDamage:CreateABtext(button, (select(selector, DrDamage:RawNumbers(tableSpell, spellName))), healingSpell, textFrame)
				else
					return DrDamage:Round( (select(selector, DrDamage:RawNumbers(tableSpell, spellName))) )
				end
			end				
		end
	end
end

function DrDamage:CreateABtext( button, cDmg, HealingSpell, frame )
	cDmg = DrDamage:Round( cDmg )
	
	if not frame then
		frame = GetTextFrame(false,button:GetChildren())
	end
	
	if frame then
		if visualChange then
			frame.text:SetFont(GameFontNormal:GetFont(), DrDamage.db.profile.FontSize, DrDamage.db.profile.FontEffect)
			frame.text:SetPoint("BOTTOMLEFT", frame ,"BOTTOMLEFT", -10 + DrDamage.db.profile.FontXPosition, DrDamage.db.profile.FontYPosition + 5)
			frame.text:SetPoint("BOTTOMRIGHT", frame ,"BOTTOMRIGHT", 10 + DrDamage.db.profile.FontXPosition, DrDamage.db.profile.FontYPosition + 5)			
			if HealingSpell then
				frame.text:SetTextColor( DrDamage.db.profile.FontColorHeal.r, DrDamage.db.profile.FontColorHeal.g, DrDamage.db.profile.FontColorHeal.b )	
			else 
				frame.text:SetTextColor( DrDamage.db.profile.FontColorDmg.r, DrDamage.db.profile.FontColorDmg.g, DrDamage.db.profile.FontColorDmg.b ) 
			end
		end
		frame.text:SetText( cDmg )
		frame.text:Show()
	else
		local dpsText = CreateFrame("Frame", "DrDamageText", button)
		dpsText:SetAllPoints(button)
		dpsText:SetFrameLevel(dpsText:GetFrameLevel() + 1)
		dpsText.text = dpsText:CreateFontString( nil, "OVERLAY")
		dpsText.text:SetPoint("BOTTOMLEFT", dpsText ,"BOTTOMLEFT", -10 + DrDamage.db.profile.FontXPosition, DrDamage.db.profile.FontYPosition + 5)
		dpsText.text:SetPoint("BOTTOMRIGHT", dpsText ,"BOTTOMRIGHT", 10 + DrDamage.db.profile.FontXPosition, DrDamage.db.profile.FontYPosition + 5)
		dpsText.text:SetFont(GameFontNormal:GetFont(), DrDamage.db.profile.FontSize, DrDamage.db.profile.FontEffect)
		dpsText.text:SetJustifyH("CENTER")
		if HealingSpell then 
			dpsText.text:SetTextColor( DrDamage.db.profile.FontColorHeal.r, DrDamage.db.profile.FontColorHeal.g, DrDamage.db.profile.FontColorHeal.b )
		else 
			dpsText.text:SetTextColor( DrDamage.db.profile.FontColorDmg.r, DrDamage.db.profile.FontColorDmg.g, DrDamage.db.profile.FontColorDmg.b ) 
		end
		
		dpsText.text:SetText( cDmg )
		dpsText.text:Show()
		
		--Fix to properly inherit parent alpha
		if button:GetAlpha() == 0 then
			button:SetAlpha( 0.01 )
			button:SetAlpha( 0 )
		end
	end
end

function DrDamage:SpecialSlot( func, button, healingSpell, textFrame )
	local text = func()
	if button and text then DrDamage:CreateABtext( button, text, healingSpell, textFrame )
	elseif text then return text end
end

function DrDamage:WandDamage()
	local selector = displayTypeTable[DrDamage.db.profile.DisplayType]
	local speed, lowDmg, hiDmg = UnitRangedDamage( "player" )
	local avgDmg = (lowDmg + hiDmg) / 2
	local avgTotal = avgDmg * ( 1 + ( GetRangedCritChance() / 100) * 0.5 )
	local DPS = DrDamage:Round( avgTotal / speed )
	local hiCritDmg = DrDamage:Round( hiDmg * 1.5 )
	
	avgTotal = DrDamage:Round( avgTotal )
	avgDmg = DrDamage:Round ( avgDmg )
	lowDmg = DrDamage:Round ( lowDmg )
	hiDmg = DrDamage:Round ( hiDmg )
	
	return select( selector, false, avgTotal, DPS, DPS, avgDmg, lowDmg, hiDmg, avgDmg, hiCritDmg )	
end

local hitDataMOB = { 95, 94, 83, 72, 61, 50, 39, 28, 17, 6 }
local hitDataPlayer = { 95, 94, 87, 80, 73, 66, 59, 52, 45, 38 }
local lastTargetLevel
local lastSpellHit

function DrDamage:SpellHit()
	local targetLevel = UnitLevel( "target" )
	local playerLevel = UnitLevel( "player" )
	local hitPerc = 99
	
	if DrDamage.db.profile.HitTarget then
		local levelDiff = 0

		if playerLevel >= 60 and targetLevel == -1 then
			levelDiff = 3
		elseif targetLevel == -1 then
			levelDiff = 10
		elseif targetLevel > playerLevel then
			levelDiff = targetLevel - playerLevel
		elseif targetLevel == playerLevel then
			hitPerc = 96
		end
		
		if levelDiff > 0 and levelDiff <= 10 then
			if UnitIsPlayer( "target" ) then
				hitPerc = hitDataPlayer[levelDiff]
			else
				hitPerc = hitDataMOB[levelDiff]
			end
		end
		
		lastTargetLevel = targetLevel
		lastSpellHit = hitPerc
		
	elseif not DrDamage.db.profile.HitTarget then
		if DrDamage.db.profile.TargetLevel >= 1 then
			if DrDamage.db.profile.TargetPlayer then
					hitPerc = hitDataPlayer[ math_floor( DrDamage.db.profile.TargetLevel ) ]
			else
					hitPerc = hitDataMOB[ math_floor( DrDamage.db.profile.TargetLevel ) ]
			end
					
		elseif math_floor( DrDamage.db.profile.TargetLevel ) == 0 then
			hitPerc = 96
		end
		
		lastTargetLevel = DrDamage.db.profile.TargetLevel
		lastSpellHit = hitPerc		
	end
	
	if select(2, UnitRace( "player" )) == "Draenei" and (playerClass == "MAGE" or playerClass == "PRIEST" or playerClass == "SHAMAN") then
		hitPerc = hitPerc + 1
	end
		
	return hitPerc
end

--Credits to the author of RatingBuster (Whitetooth) for the formula!
function DrDamage:GetRating( hit, convertR, full )
	local playerLevel = UnitLevel("player")
	local base = 14
	local rating = 0

	if hit then base = 8 end

	if playerLevel > 9 and playerLevel <= 60 then
		rating = base / ( ( playerLevel - 8 ) / 52 )
	elseif playerLevel <= 70 then
		rating = base / ( 131/41 - 3/82 * playerLevel  )
	end

	if full then
		if convertR then
			return ( convertR / rating )
		else
			return rating
		end
	else
		if convertR then
			return DrDamage:Round( convertR / rating, 2 )
		else
			return DrDamage:Round( rating, 2 )
		end
	end
end

function DrDamage:TotalAP()
	local baseAP, posBuff, negBuff = UnitAttackPower( "player" )
	return baseAP + posBuff + negBuff
end

function DrDamage:GetSpellInfo( spellName, spellRank )
	if spellName and spellRank then
		if spellInfo[spellName] then
			return spellInfo[spellName][spellRank] or spellInfo[spellName]["None"]
		end
	end
end

--Static tables
local schoolTable = { ["Holy"] = 2, ["Fire"] = 3, ["Nature"] = 4, ["Frost"] = 5, ["Shadow"] = 6, ["Arcane"] = 7 }

--Temporary tables
local calculation = {}
local CalculationResults = {}
local BuffTalentRanks = {}
local ActiveAuras = {}

function DrDamage:RawNumbers( spell, lSpellName, tooltip )
	if not spell or not lSpellName then
		do return end
	end
	
	local spellName = lSpellName

	if BS:HasReverseTranslation( spellName ) then
		spellName = BS:GetReverseTranslation( spellName )
	end
	
	local baseSpell = spellInfo[lSpellName][0]							--Base spell information
	local healingSpell = baseSpell.Healing or DrDamage:MatchData(baseSpell.School, "Healing")	--Healing spell (boolean)
	
	calculation.hitPerc = lastSpellHit								--Hit chance (%)	
	calculation.castTime = spell.castTime or baseSpell.castTime or 1.5				--Cast time
	calculation.eDuration = spell.eDuration or baseSpell.eDuration or 1				--Effect duration
	calculation.sHits = spell.sHits or baseSpell.sHits						--Amount of hits(ticks) of spell
	calculation.critM = 0.5										--Crit multiplier
	calculation.bNukeDmg = 0									--Modifier for spells with a DOT portion
	calculation.dmgM = 1										--Damage multiplier (total)
	calculation.bDmgM = 1										--Base damage Modifier
	calculation.spellDmgM_AddTalent = 0								--Talents: Spell damage multiplier additive	
	calculation.dmgM_AddTalent = 0									--Talents: Damage multiplier additive
	calculation.spellDmgM_AddNoDownrank = 0								--Additive spell damage modifier (not affected by downranking)
	calculation.dotSpellDmgM = 0									--Dot portion spelldamage modifier
	calculation.cooldown = baseSpell.Cooldown or 0							--Spell's cooldown
	calculation.finalMod = 0									--Modifier to final damage +/-
	calculation.dotFinalMod = 0									--Modifier to final dot damage +/-
	calculation.minDam = spell[1]									--Spell initial base min damage
	calculation.maxDam = spell[2]									--Spell initial base max damage
	calculation.chainFactor = baseSpell.chainFactor							--Chain effect spells
	calculation.manaRegen = select(2, GetManaRegen( "player" ))					--Mana regen while casting	
		
	if type( baseSpell.School ) == "table" then
		calculation.spellSchool = baseSpell.School[1]
		calculation.spellType = baseSpell.School[2]
	else
		calculation.spellSchool = baseSpell.School
	end
	
	calculation.healingSpell = healingSpell
	
	--Calculate spelldamage
	if healingSpell then
		calculation.spellDmg = GetSpellBonusHealing() 						-- +healing
	else
		calculation.spellDmg = GetSpellBonusDamage(schoolTable[calculation.spellSchool] or 1) 	--+all spelldamage
	end
	
	--Calculate spelldamage modifier
	if baseSpell.bonusFactor then
		calculation.spellDmgM = baseSpell.bonusFactor
	elseif baseSpell.eDot then 
		calculation.spellDmgM = ( calculation.eDuration / 15)
	else
		calculation.spellDmgM = ( calculation.castTime / 3.5) 
	end
	
	--Calculate base hit chance (only if needed)
	if DrDamage.db.profile.HitTarget and UnitLevel( "target" ) ~= lastTargetLevel then
		calculation.hitPerc = DrDamage:SpellHit() 		
	elseif not DrDamage.db.profile.HitTarget and DrDamage.db.profile.TargetLevel ~= lastTargetLevel then
		calculation.hitPerc = DrDamage:SpellHit()
	end	
	
	--Calculate crit/hit
	if not DrDamage:MatchData( baseSpell.School, "Physical" ) then
		calculation.critPerc = GetSpellCritChance(schoolTable[calculation.spellSchool] or 1)
		calculation.hitPerc = calculation.hitPerc + GetCombatRatingBonus( 8 )
	else
		calculation.critPerc = GetCritChance()
		calculation.critM = 1
		calculation.hitPerc = calculation.hitPerc + GetCombatRatingBonus( 6 )
	end
		
	if DrDamage.db.profile.ManaConsumables then
		calculation.manaRegen = calculation.manaRegen + 20 
	end
	
	--Random item bonuses to base values not supplied by API
	if DrDamage.RelicSlot then
		if DrDamage.RelicSlot[spellName] then
			local data = DrDamage.RelicSlot[spellName]
			local count = #data
			if count then
				for i = 1, count - 1, 2 do
					if data[i] and data[i+1] then
						if IsEquippedItem( data[i] ) then
							local modType = data["ModType"..((i+1)/2)]
							
							if not modType then
								calculation.spellDmg = calculation.spellDmg + data[i+1]
							elseif modType == "Base" then
								calculation.minDam = calculation.minDam + data[i+1]
								calculation.maxDam = calculation.maxDam + data[i+1]
							elseif modType == "Final" then
								calculation.finalMod = calculation.finalMod + data[i+1]
							elseif modType == "Dot" then
								calculation.dotFinalMod = calculation.dotFinalMod + data[i+1]
							end
						end
					end
				end
			end
		end
	end
	
	if not healingSpell then
		if UnitCreatureType( "target" ) == "Undead" then
			if IsEquippedItem( 19182 ) then								--Rune of the Dawn
				if not baseSpell.NoBuffs then
					calculation.spellDmg = spellDmg + 48
				end	
			end
		elseif UnitCreatureType( "target" ) == "Demon" then
			if IsEquippedItem( 30787 ) then								--Illidari-Bane Mageblade
				if not baseSpell.NoBuffs then
					calculation.spellDmg = spellDmg + 185
				end
			end		
		end	
	end	
	
	--Manual variables from profile:
	if DrDamage.db.profile.ManualDmg then
		if not DrDamage.db.profile.ManualPlus then
			if healingSpell then
				calculation.spellDmg = DrDamage.db.profile.Healing
			else
				calculation.spellDmg = DrDamage.db.profile.SpellDamage
			end
			if not DrDamage:MatchData( baseSpell.School, "Physical" ) then
				calculation.critPerc = calculation.critPerc - GetCombatRatingBonus(11) + DrDamage:GetRating( false, DrDamage.db.profile.CritRating, true )
				calculation.hitPerc = calculation.hitPerc - GetCombatRatingBonus(8) + DrDamage:GetRating( true, DrDamage.db.profile.HitRating, true )
			else
				calculation.critPerc = calculation.critPerc - GetCombatRatingBonus(9) + DrDamage:GetRating( false, DrDamage.db.profile.CritRating, true )
				calculation.hitPerc = calculation.hitPerc - GetCombatRatingBonus(6) + DrDamage:GetRating( true, DrDamage.db.profile.HitRating, true )
			end	
		else
			if healingSpell then
				calculation.spellDmg = calculation.spellDmg + DrDamage.db.profile.Healing
			else
				calculation.spellDmg = calculation.spellDmg + DrDamage.db.profile.SpellDamage
			end
			calculation.critPerc = calculation.critPerc + DrDamage:GetRating( false, DrDamage.db.profile.CritRating, true )
			calculation.hitPerc = calculation.hitPerc + DrDamage:GetRating( true, DrDamage.db.profile.HitRating, true )
		end
		
		if not healingSpell then
			local plus = DrDamage.db.profile[calculation.spellSchool.."Damage"]
			if plus then calculation.spellDmg = calculation.spellDmg + plus end
		else
			calculation.spellDmg = calculation.spellDmg + DrDamage.db.profile.Healing
		end
		
		if calculation.spellDmg < 0 then calculation.spellDmg = 0 end
		if calculation.critPerc < 0 then calculation.critPerc = 0 end
		if calculation.hitPerc < 0 then calculation.hitPerc = 0 end
	end
								
	--Apply talents		
	for talentName, talentRank in pairs( talents ) do						
		local talent = talentEffects[talentName]						 
		local talentValue
				
		if type( talent.Effect ) == "table" then
			talentValue = talent.Effect[talentRank]
		else
			talentValue = talentRank * talent.Effect
		end

		for _, talentSpell in ipairs( talent.Spells ) do
			DrDamage:TalentCalc( baseSpell, spellName, talentName, talentSpell, talentValue, talent.ModType, talent.Add, talent.Multiply  )
		end

		if talent.Spells2 then
			if talent.Effect2 then talentValue = talentRank * talent.Effect2 end

			for _, talentSpell in ipairs( talent.Spells2 ) do
				DrDamage:TalentCalc( baseSpell, spellName, talentName, talentSpell, talentValue, talent.ModType2, talent.Add2, talent.Multiply2 )
			end
		end		
	end
	
	--Add up additive components:
	calculation.dmgM = calculation.dmgM + calculation.dmgM_AddTalent
	calculation.spellDmgM = calculation.spellDmgM + calculation.spellDmgM_AddTalent	
			
	--Start calculating Buffs/Debuffs that affects damage not provided by blizzard API.
	
	--BUFF/DEBUFF -- DAMAGE/HEALING -- PLAYER
	if DrDamage.PlayerAura and not baseSpell.NoBuffs then
		for buffName, index, apps, texture, rank in SEA:BuffIter( "player" ) do
			if BS:HasReverseTranslation( buffName ) then
				buffName = BS:GetReverseTranslation( buffName )
			end		
		
			if DrDamage.PlayerAura[buffName] then
				local buffData = DrDamage.PlayerAura[buffName]
			
				if not healingSpell
					and ( DrDamage:MatchData( buffData.School, calculation.spellSchool ) and not baseSpell.NoSchoolBuffs
					or ( not buffData.School and not buffData.Spell ))
					or DrDamage:MatchData( buffData.School, calculation.spellType )
				or healingSpell 
					and buffData.School == "Healing"
				or buffData.School == "All" and spellType ~= "Physical"
				or DrDamage:MatchData( buffData.Spell, lSpellName ) then
					if buffData.ModType == "Special" and self.Calculation[buffName] then
						self.Calculation[buffName]( calculation, ActiveAuras, BuffTalentRanks, index, apps, texture, rank )
					else
						DrDamage:BuffCalc( buffName, buffData, index, apps, texture, rank, lSpellName )
					end				
				end
			end		
		end
		for buffName, apps, _, texture, rank, index in SEA:DebuffIter( "player" ) do
			if BS:HasReverseTranslation( buffName ) then
				buffName = BS:GetReverseTranslation( buffName )
			end		
		
			if DrDamage.PlayerAura[buffName] then
				local buffData = DrDamage.PlayerAura[buffName]
				
				if not healingSpell 
					and ( DrDamage:MatchData( buffData.School, calculation.spellSchool ) 
					or ( not buffData.School and not buffData.Spell ))
				or healingSpell 
					and buffData.School == "Healing"					
				or DrDamage:MatchData( buffData.Spell, lSpellName ) then	
					if buffData.ModType == "Special" and self.Calculation[buffName] then
						self.Calculation[buffName]( calculation, ActiveAuras, BuffTalentRanks, index, apps, texture, rank )
					else
						DrDamage:BuffCalc( buffName, buffData, index, apps, texture, rank, lSpellName )
					end
				end
			end
		end
	end	
	
	--DEBUFF -- DAMAGE/HEALING -- TARGET
	if DrDamage.Debuffs and not baseSpell.NoDebuffs then
		local debuffTarget
		
		if not healingSpell then
			debuffTarget = "target"
		elseif UnitIsFriend( "player", "target" ) then
			debuffTarget = "target"
		elseif UnitIsFriend( "player", "targettarget" ) then
			debuffTarget = "targettarget" 
		end		

		if debuffTarget then
			local socStun			--Target is stunned?		
		
			for buffName, apps, _, texture, rank, index in SEA:DebuffIter( debuffTarget ) do
				if BS:HasReverseTranslation( buffName ) then
					buffName = BS:GetReverseTranslation( buffName )
				end

				if DrDamage.Debuffs[buffName] then
					local buffData = DrDamage.Debuffs[buffName]
					local modType = buffData.ModType				

					if not healingSpell 
						and ( DrDamage:MatchData( buffData.School, calculation.spellSchool ) and not baseSpell.NoSchoolBuffs
						or not buffData.School and not buffData.Spell )
						or DrDamage:MatchData( buffData.School, calculation.spellType )
					or healingSpell and buffData.School == "Healing"
					or DrDamage:MatchData( buffData.Spell, lSpellName )
					then
						if modType == "Special" and self.Calculation[buffName] then
							self.Calculation[buffName]( calculation, ActiveAuras, BuffTalentRanks, index, apps, texture, rank )
						elseif buffData.Stun and not socStun then
							socStun = true
							calculation.bDmgM = calculation.bDmgM + 1
						else
							if buffData.Affliction then
								if BuffTalentRanks["Soul Siphon"] then
									ActiveAuras["Soul Siphon"] = ( ActiveAuras["Soul Siphon"] or 0 ) + 1
								end
							end
							DrDamage:BuffCalc( buffName, buffData, index, apps, texture, rank, lSpellName )
						end
					end
				end
			end
		end
	end
		
	--BUFF - HEALING -- TARGET
	if healingSpell and DrDamage.HealingBuffs then
		local healingTarget
		
		if UnitIsFriend( "player", "target" ) then
			healingTarget = "target"
		elseif UnitIsFriend( "player", "targettarget" ) then
			healingTarget = "targettarget" 
		end
		
		if healingTarget then
			for buffName, index, apps, texture, rank in SEA:BuffIter( healingTarget ) do
				if BS:HasReverseTranslation( buffName ) then
					buffName = BS:GetReverseTranslation( buffName )
				end		

				if DrDamage.HealingBuffs[buffName] then
					local buffData = DrDamage.HealingBuffs[buffName]

					if not buffData.Spell or DrDamage:MatchData( buffData.Spell, lSpellName ) then
						if buffData.ModType == "Special" and self.Calculation[buffName] then
							self.Calculation[buffName]( calculation, ActiveAuras, BuffTalentRanks, index, apps, texture, rank )
						else
							DrDamage:BuffCalc( buffName, buffData, index, apps, texture, rank, lSpellName )
						end
					end
				end
			end
		end
	end
		
	--Modified factors
	
	--Split between bonus to dot and nuke
	if baseSpell.hybridFactor then
		calculation.spellDmgM = calculation.spellDmgM * baseSpell.hybridFactor
	end
	
	--Factor that applies to all ranks of the spell
	if baseSpell.sFactor then
		calculation.spellDmgM = calculation.spellDmgM * baseSpell.sFactor
	end
	
	--Factor that applies to current rank of the spell
	if spell.sFactor then
		calculation.spellDmgM = calculation.spellDmgM * spell.sFactor
	end
	
	--Factor for downranking
	local lowRankFactor = 1
	
	if not baseSpell.NoDownRank then
		local playerLevel = UnitLevel("player")
		local downRankMod = spell.Downrank or baseSpell.Downrank or 0
		lowRankFactor = ( spell.spellLevel + 11 + downRankMod ) / playerLevel

		if lowRankFactor < 1 then
			calculation.spellDmgM = calculation.spellDmgM * lowRankFactor
		else
			lowRankFactor = 1
		end
	end
	
	--Factor for spells under level 20
	local lowLevelFactor = 1
	
	if spell.spellLevel and spell.spellLevel < 20 and not baseSpell.NoLowLevelPenalty then
		lowLevelFactor = 1 - ((20 - spell.spellLevel) * 0.0375)
		
		if lowLevelFactor < 1 and lowLevelFactor > 0 then
			calculation.spellDmgM = calculation.spellDmgM * lowLevelFactor
		else
			lowLevelFactor = 1
		end
	end
	
	--Add additive components with no downranking effect
	calculation.spellDmgM = calculation.spellDmgM + calculation.spellDmgM_AddNoDownrank
	
	--Adding to spells base damage after levelups:
	if baseSpell.BaseIncrease then
		local playerLevel = UnitLevel("player")
	
		if playerLevel > spell.spellLevel then
			local spellmaxLevel
			if baseSpell.LevelIncrease then
				spellmaxLevel = spell.spellLevel + baseSpell.LevelIncrease
				if spellmaxLevel > 70 then spellmaxLevel = 70 end
			else
				spellmaxLevel = 70
			end
			if playerLevel >= spellmaxLevel then
				calculation.minDam = calculation.minDam + spell[3]
				calculation.maxDam = calculation.maxDam + spell[4]			
			else
				local diff = spellmaxLevel - spell.spellLevel
				
				calculation.minDam = calculation.minDam + ( playerLevel - spell.spellLevel ) * ( spell[3] / diff )
				calculation.maxDam = calculation.maxDam + ( playerLevel - spell.spellLevel ) * ( spell[4] / diff )
			end
		end
		
		calculation.minDam = math_floor( calculation.minDam )
		calculation.maxDam = math_ceil( calculation.maxDam )
	end

	if self.SetBonuses[playerClass] then
		self.SetBonuses[playerClass]( calculation, ActiveAuras )
	end		
	if self.Calculation[playerClass] then
		self.Calculation[playerClass]( calculation, ActiveAuras, BuffTalentRanks )
	end
	if self.SetBonuses[spellName] then
		self.SetBonuses[spellName]( calculation, ActiveAuras )
	end
	if self.Calculation[spellName] then
		self.Calculation[spellName]( calculation, ActiveAuras, BuffTalentRanks, spell )
	end	
	
	local function DmgCalc( next, hitCalc )
	
		--Initialize variables that are calculated
		local dispSpellDmgM = calculation.spellDmgM	--Calculated spelldamage modifier		
		local calcAvgDmgCrit = 0			--Calculated final damage with averaged crit
		local calcAvgDmg = 0				--Calculated final damage without crit
		local calcDotDmg = 0				--Calculated DOT portion
		local calcMinDmg = 0				--Calculated dmg range: min
		local calcMaxDmg = 0				--Calculated dmg range: max
		local calcDPS
		local calcMinCrit				--Calculated crit range: min
		local calcMaxCrit				--Calculated crit range: max
		local igniteDotDmg				--Calculated ignite DOT portion
		local avgIgnite					--Calculated average ignite
		local perHit					--Calculated damage per hit
		local extraDmg				
		local extraDPS
		local baseDuration = spell.eDuration or baseSpell.eDuration
		
		if calculation.sHits then
			calcMinDmg = calculation.dmgM * ( calculation.bDmgM * calculation.minDam * calculation.sHits + (  calculation.spellDmg * calculation.spellDmgM ) )
			calcMaxDmg = calculation.dmgM * ( calculation.bDmgM * calculation.maxDam * calculation.sHits + (  calculation.spellDmg * calculation.spellDmgM ) )
		elseif spell.hybridDotDmg then
			calcMinDmg = ( calculation.dmgM + calculation.bNukeDmg ) * ( calculation.bDmgM * calculation.minDam + ( calculation.spellDmg * calculation.spellDmgM ) )
			calcMaxDmg = ( calculation.dmgM + calculation.bNukeDmg ) * ( calculation.bDmgM * calculation.maxDam + ( calculation.spellDmg * calculation.spellDmgM ) )
		else
			calcMinDmg = calculation.dmgM * ( calculation.bDmgM * calculation.minDam + ( calculation.spellDmg * calculation.spellDmgM ) )
			calcMaxDmg = calculation.dmgM * ( calculation.bDmgM * calculation.maxDam + ( calculation.spellDmg * calculation.spellDmgM ) )
		end
				
		if calculation.finalMod ~= 0 then
			if calculation.finalMod > 0 then
				calcMinDmg = calcMinDmg + calculation.finalMod * calculation.dmgM * lowLevelFactor
				calcMaxDmg = calcMaxDmg + calculation.finalMod * calculation.dmgM * lowLevelFactor
			else
				calcMinDmg = calcMinDmg + calculation.finalMod
				calcMaxDmg = calcMaxDmg + calculation.finalMod
			end
				
			if calcMinDmg < 0 then
				calcMinDmg = 0
			end
			
			if calcMaxDmg < 0 then
				calcMaxDmg = 0
			end	
		end
		
		--This is for Imp SW:P and others with extended duration through talents etc.
		if baseSpell.eDot and baseSpell.eDuration and calculation.eDuration > baseDuration then
			calcMinDmg = calcMinDmg + (calcMinDmg / baseDuration) * (calculation.eDuration - baseDuration)
			calcMaxDmg = calcMaxDmg + (calcMaxDmg / baseDuration) * (calculation.eDuration - baseDuration)
		end		
		
		calcAvgDmg = (calcMinDmg + calcMaxDmg) / 2
						
		--Crit calculation:
		local critBonus = 0
		
		if calculation.critPerc > 100 then
			calculation.critPerc = 100
		end
		
		if baseSpell.canCrit then
			calcMinCrit = calcMinDmg + calcMinDmg * calculation.critM
			calcMaxCrit = calcMaxDmg + calcMaxDmg * calculation.critM
			critBonus = ( calculation.critPerc / 100 ) * calcAvgDmg * calculation.critM
			calcAvgDmgCrit = calcAvgDmg + critBonus
		else
			calcAvgDmgCrit = calcAvgDmg
			calculation.critPerc = 0;
		end

		--Hit calculation:
		if calculation.hitPerc > 99 then
			calculation.hitPerc = 99
		end
		
		if not healingSpell and not baseSpell.Unresistable then
			if DrDamage.db.profile.HitCalc or hitCalc then
				if DrDamage.db.profile.TwoRoll then
					calcAvgDmgCrit = calcAvgDmgCrit * ( calculation.hitPerc / 100 )
				else
					calcAvgDmgCrit = ( calcAvgDmgCrit - critBonus ) * ( calculation.hitPerc / 100 ) + critBonus
				end
			end
		end		
		
		--Hybrid spells:
		local hybridDmgM = 0
		
		if spell.hybridDotDmg then
			local hybridFactor = baseSpell.hybridFactor or 0
			local sFactor = 1
			
			if baseSpell.sFactor then
				sFactor = baseSpell.sFactor * sFactor
			end

			if spell.sFactor then
				sFactor = spell.sFactor * sFactor
			end

			if baseSpell.hybridDotFactor then
				sFactor = baseSpell.hybridDotFactor * sFactor
			end
			
			hybridDmgM = ( baseDuration / 15 + calculation.dotSpellDmgM ) * ( 1 - hybridFactor ) * sFactor * lowRankFactor * lowLevelFactor
			calcDotDmg = calculation.dmgM * ( hybridDmgM * calculation.spellDmg + spell.hybridDotDmg )
			dispSpellDmgM = dispSpellDmgM + hybridDmgM
		
			if calculation.eDuration > baseDuration then 
				calcDotDmg = calcDotDmg + ( calcDotDmg / baseDuration ) * ( calculation.eDuration - baseDuration )
			end
		end
		
		--For spells that can ignite
		if calculation.igniteM then
			igniteDotDmg = calculation.igniteM * (( calcMinCrit + calcMaxCrit ) / 2 )
			avgIgnite = ( calculation.critPerc / 100 ) * igniteDotDmg
			calcAvgDmgCrit = calcAvgDmgCrit + avgIgnite
		end
		
		--For spells with extra DOT portion eg. fireball
		if spell.extraDotDmg then
			local xFactor = baseSpell.extraDotF or 0
			calcDotDmg = calcDotDmg + calculation.dmgM * ( spell.extraDotDmg + xFactor * lowRankFactor * lowLevelFactor * calculation.spellDmg )
			dispSpellDmgM = dispSpellDmgM + xFactor * lowRankFactor * lowLevelFactor
		end
		
		calcDotDmg = calcDotDmg + calculation.dotFinalMod
		
		--For chain effects (chain lightning, chain heal)
		local chainEffect
		
		if calculation.chainFactor then
			chainEffect = calcAvgDmgCrit * ( calculation.chainFactor + ( calculation.chainFactor ^ 2 ) + ( calculation.chainFactor ^ 3 ) )
			calcAvgDmgCrit = calcAvgDmgCrit + chainEffect
		end
					
		--DPS calculations
		if calculation.castTime < 1.5 and baseSpell.Instant then
			calculation.castTime = 1.5
		end
	
		if baseSpell.eDot or spell.hybridDotDmg then
			calcDPS = ( calcAvgDmgCrit + calcDotDmg ) / calculation.eDuration
		elseif spell.extraDotDmg then
			calcDPS = calcAvgDmgCrit / calculation.castTime + calcDotDmg / calculation.eDuration
		else
			calcDPS = calcAvgDmgCrit / calculation.castTime
		end

		calcAvgDmgCrit = calcAvgDmgCrit + calcDotDmg
		
		--Special cases:
		if spellName == "Seed of Corruption" then
			calcAvgDmgCrit = calcAvgDmgCrit - calcDotDmg + math_ceil( ( 6 * 1044 ) / calcDotDmg ) * ( calcDotDmg / 6 )
			perHit = calcDotDmg / 6
			calcDotDmg = math_ceil( ( 6 * 1044 ) / calcDotDmg ) * ( calcDotDmg / 6 )
		end
		
		if not next then
			local DPS = 			DrDamage:Round( calcDPS, 1 )
			local DPSC = 			DrDamage:Round( calcAvgDmgCrit / calculation.castTime, 1 )
			local Avg =			DrDamage:Round( calcAvgDmg )
			local MinDmg = 			math_floor( calcMinDmg )
			local MaxDmg = 			math_ceil( calcMaxDmg )
			local AvgHitTotal =		DrDamage:Round( calcAvgDmg + calcDotDmg  )
			local MaxCritDmg =		calcDotDmg
			
			if calcMaxCrit then MaxCritDmg = MaxCritDmg + calcMaxCrit else MaxCritDmg = MaxCritDmg + calcMaxDmg end
			if igniteDotDmg then MaxCritDmg = MaxCritDmg + igniteDotDmg end
			if extraDmg then MaxCritDmg = MaxCritDmg + extraDmg end
			if chainEffect then MaxCritDmg = MaxCritDmg + chainEffect end
			
			--Write tooltip data
			if tooltip then

				if baseSpell.Cooldown then
					CalculationResults.DPSCD = 	DrDamage:Round( calcAvgDmgCrit / calculation.cooldown, 1 )
				end
				
				if baseSpell.canCrit then
					CalculationResults.MinCrit =	math_floor( calcMinCrit )
					CalculationResults.MaxCrit = 	math_ceil( calcMaxCrit )
					CalculationResults.AvgCrit = 	DrDamage:Round( ( calcMinCrit + calcMaxCrit ) / 2 )
					CalculationResults.CritRate = 	DrDamage:Round( calculation.critPerc, 2 )
					
					--Lightning capacitor
					if not healingSpell and IsEquippedItem( 28785 ) and not DrDamage:MatchData( baseSpell.School, "OffensiveTotem", "Physical" ) then
						extraDmg = ( (( 694 + 806 ) / 2 ) * ( 1 + ( GetSpellCritChance(schoolTable["Nature"]) / 100 ) * 0.5 ) ) / ( 300 / calculation.critPerc )
						
						if calculation.sHits then
							extraDmg = calculation.sHits * extraDmg
						end
						
						extraDPS = extraDmg / calculation.castTime
					end
				end
				
				CalculationResults.HitRate = 	DrDamage:Round( calculation.hitPerc, 2 )
				CalculationResults.DotDmg = 	DrDamage:Round( calcDotDmg )
				CalculationResults.SpellDmg = 	DrDamage:Round( calculation.spellDmg )
				CalculationResults.SpellDmgM = 	DrDamage:Round( dispSpellDmgM, 3 )
				CalculationResults.DmgM = 	DrDamage:Round( calculation.dmgM, 3 )
				CalculationResults.IgniteDmg = 	DrDamage:Round( igniteDotDmg )
				CalculationResults.ChainDmg = 	DrDamage:Round( chainEffect )
				
				CalculationResults.CastTime = 	calculation.castTime
				CalculationResults.Cooldown = 	calculation.cooldown
				CalculationResults.ManaRegen = 	calculation.manaRegen
				CalculationResults.FreeCrit = 	calculation.freeCrit
				
				CalculationResults.ExtraDPS = 	DrDamage:Round( extraDPS, 1 )
			
				local sTicks = baseSpell.sTicks or spell.sTicks
				local ticks

				if calculation.sHits then
					ticks = calculation.sHits
					perHit = calcAvgDmg / calculation.sHits
				elseif sTicks then
					if calculation.castTime > calculation.eDuration then
						ticks = calculation.castTime / sTicks
					else
						ticks = calculation.eDuration / sTicks
					end
					
					if spellName == "Seed of Corruption" then
						ticks = math_ceil( 1044 / perHit )
						CalculationResults.SpellDmgM = DrDamage:Round( dispSpellDmgM -  ( hybridDmgM - ( hybridDmgM / 6 ) * ticks ), 3 )
					else
						if spell.hybridDotDmg or spell.extraDotDmg then
							perHit = calcDotDmg / ticks
						else
							perHit = calcAvgDmg / ticks
						end
					end
				end		
				
				if baseSpell.Leech then
					if calculation.LeechBonus then
						CalculationResults.AvgLeech = DrDamage:Round( calcAvgDmgCrit * calculation.LeechBonus, 1 )
					end
				end
				
				if perHit and ticks then
					CalculationResults.PerHit = DrDamage:Round( perHit, 1 )
					CalculationResults.Hits = ticks
					
					if baseSpell.Leech then
						if calculation.LeechBonus then
							CalculationResults.PerHitHeal =  DrDamage:Round( perHit * calculation.LeechBonus, 1 )
						end
					end
				end
			end
					
			return calcAvgDmgCrit, DPS, DPSC, Avg, MinDmg, MaxDmg, AvgHitTotal, MaxCritDmg
		end
				
		return calcAvgDmgCrit
	end
	
	local returnAvgTotal, returnDPS, returnDPSC, returnAvg, returnMinDmg, returnMaxDmg, returnAvgHitTotal, returnMaxCritDmg = DmgCalc()
	
	if tooltip then
		if DrDamage.db.profile.Next then
			if baseSpell.canCrit then
				calculation.critPerc = calculation.critPerc + 1
				CalculationResults.NextCrit = DrDamage:Round( DmgCalc( true ) - returnAvgTotal, 1 )
				calculation.critPerc = calculation.critPerc - 1	
			end

			calculation.spellDmg = calculation.spellDmg + 10
			CalculationResults.NextTenDmg = DrDamage:Round( DmgCalc( true ) - returnAvgTotal, 1 )
			calculation.spellDmg = calculation.spellDmg - 10

			if not healingSpell and not baseSpell.Unresistable then
			
				local temp
				
				if DrDamage.db.profile.HitCalc then
					temp = returnAvgTotal
				else
					temp = DmgCalc( true, true )
				end
				
				calculation.hitPerc = calculation.hitPerc + 1
				CalculationResults.NextHit = DrDamage:Round( DmgCalc( true, true ) - temp, 1 )
				calculation.hitPerc = calculation.hitPerc - 1
			end	
		end		
	end
	
	DrDamage:ClearTable( BuffTalentRanks )
	DrDamage:ClearTable( ActiveAuras )
	DrDamage:ClearTable( calculation )
	
	return healingSpell, DrDamage:Round( returnAvgTotal ), returnDPS, returnDPSC, returnAvg, returnMinDmg, returnMaxDmg, returnAvgHitTotal, returnMaxCritDmg, CalculationResults
end

function DrDamage:TalentCalc( baseSpell, spellName, talentName, talentSpell, talentValue, ModType, add, multiply )
	if ( talentSpell == "All" or talentSpell == calculation.spellSchool ) and not baseSpell.NoSchoolTalents or talentSpell == calculation.spellType or talentSpell == spellName then
		if not ModType then
			if add then
				calculation.dmgM_AddTalent = calculation.dmgM_AddTalent + talentValue
			else
				calculation.dmgM = calculation.dmgM * ( 1 + talentValue )	
			end					
		elseif ModType == "SpellDamage" then
			if multiply then
				calculation.spellDmgM = calculation.spellDmgM * ( 1 + talentValue )
			else
				calculation.spellDmgM_AddTalent = calculation.spellDmgM_AddTalent + talentValue
			end
		elseif ModType == "Crit" then
			calculation.critPerc = calculation.critPerc + talentValue
		elseif ModType == "Hit" then
			calculation.hitPerc = calculation.hitPerc + talentValue							
		elseif ModType == "CastTime" then
			if baseSpell.CastMod then
				calculation.castTime = calculation.castTime - baseSpell.CastMod * talentValue
			end

			if baseSpell.CastModDmg then
				calculation.spellDmgM = calculation.spellDmgM * ( 1 - baseSpell.CastModDmg * talentValue )
			end
		elseif ModType == "BaseNuke" then
			calculation.bNukeDmg = talentValue
		elseif ModType == "BaseDamage" then
			calculation.bDmgM = calculation.bDmgM + talentValue
		elseif ModType == "DotSpellDamage" then
			calculation.dotSpellDmgM = calculation.dotSpellDmgM + talentValue
		elseif ModType == "CritMultiplier" then
			calculation.critM = calculation.critM + talentValue
		elseif ModType == "SpellDuration" then
			calculation.eDuration = calculation.eDuration + talentValue
		elseif ModType == "Cooldown" then
			calculation.cooldown = calculation.cooldown - talentValue
		elseif ModType == "Ignite" then
			calculation.igniteM = talentValue	
		elseif ModType == "BuffTalentRanks" then
			BuffTalentRanks[talentName] = talentValue
		elseif ModType == "FreeCrit" then
			calculation.freeCrit = talentValue
		end

		if ModType then
			if self.Calculation[ModType] then self.Calculation[ModType]( calculation, talentValue ) end
		end
	end				
end

function DrDamage:BuffCalc( bName, bData, index, apps, texture, rank, spellName )
	if bData.ActiveAura then
		if apps and apps > 0 then
			ActiveAuras[bName] = apps
		else
			ActiveAuras[bName] = ( ActiveAuras[bName] or 0 ) + 1
		end
	end

	if not bData.Value then return end
	
	local modType = bData.ModType

	if bData.Ranks then
		if rank then
			rank = tonumber(rank:match("%d+"))
		end
		if not rank then
			rank = bData.Ranks
		end

		if not modType then
			calculation.dmgM = calculation.dmgM * ( 1 + rank * bData.Value )				
		elseif modType == "RankTable" then
			calculation.spellDmg = calculation.spellDmg + bData.Value[rank]
		elseif modType == "RankTable2" then
			if spellName == bData.Spell[1] then
				calculation.finalMod = calculation.finalMod + bData.Value[rank]
			elseif spellName == bData.Spell[2] then
				calculation.finalMod = calculation.finalMod + bData.Value2[rank]
			end
		elseif modType == "JotC" then
			ActiveAuras[bName] = bData.Value[rank]											
		end
	elseif bData.Apps then
		if apps and apps > 0 then
			if modType == "Crit" then
				calculation.critPerc = calculation.critPerc + apps * bData.Value
			elseif modType == "BaseDamage" then
				calculation.bDmgM = calculation.bDmgM + apps * bData.Value
			elseif modType == "CastTime" then
				if bData.Value < 0 then
					calculation.castTime = calculation.castTime + apps * bData.Value
				end
			elseif not modType then
				if GetRealZoneText() == "Naxxramas" and ( bName == "Positive Charge" or bName == "Negative Charge" ) then
					calculation.dmgM = calculation.dmgM * ( 1 + apps * ( bData.Value / 10 ) )
				else
					calculation.dmgM = calculation.dmgM * ( 1 + apps * bData.Value )
				end			
			end
		end
	elseif bData.Texture and texture and string.find( texture, bData.Texture ) then
		calculation.dmgM = calculation.dmgM * ( 1 + bData.Value )
	elseif bData.Apps2 then
		calculation.dmgM = calculation.dmgM * ( 1 + apps * bData.Value2 )
	elseif modType == "CastTime" then
		if bData.Value < 0 then
			calculation.castTime = calculation.castTime + bData.Value
		else
			calculation.castTime = calculation.castTime * bData.Value
		end
	elseif modType == "BaseDamage" then
		calculation.bDmgM = calculation.bDmgM + bData.Value
	elseif modType == "SpellDamage" then
		calculation.spellDmgM = calculation.spellDmgM + bData.Value
	elseif modType == "Crit" then
		calculation.critPerc = calculation.critPerc + bData.Value
	elseif modType == "Hit" then
		calculation.hitPerc = calculation.hitPerc + bData.Value
	elseif not modType then
		calculation.dmgM = calculation.dmgM * ( 1 + bData.Value )
	end
end

function DrDamage:Round(x, y)
	if type( x ) ~= "number" then
		return x
	end

	y = y or 0
	
	x = x * 10 ^ y
	
	if (x > 0) then
		x = math_floor(x+0.5)
  	else
    		x = math_ceil(x-0.5)
  	end
  	
  	x = x / 10 ^ y
  	
  	return x
end